  <!--
 * @Author: zhp
 * @Date: 2023-02-14 15:02:26
 * @LastEditTime: 2023-07-13 15:35:17
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-form :model="dataForm" ref="dataForm" :rules="dataRule" @keyup.enter.native="dataFormSubmitHandle()"
    label-width="120px">
    <el-form-item prop="customerName" :label="$t('customerquality.customerName')">
      <el-input v-model="dataForm.customerName" :placeholder="$t('customerquality.customerName')"></el-input>
    </el-form-item>
    <el-form-item prop="currentStage" :label="$t('basic.status')">
      <el-select v-model="dataForm.currentStage" :placeholder="$t('basic.status')">
        <el-option v-for="item in currentStageList" :key="item.value" :label="item.label" :value="item.value">
        </el-option>
      </el-select>
    </el-form-item>
    <el-form-item prop="serialNumber" :label="$t('customerquality.serialNumber')">
      <el-input v-model="dataForm.serialNumber" :placeholder="$t('customerquality.serialNumber')"></el-input>
    </el-form-item>
    <el-form-item prop="description" :label="$t('customerquality.description')">
      <el-input v-model="dataForm.description" :placeholder="$t('customerquality.description')"></el-input>
    </el-form-item>
    <el-form-item prop="questionType" :label="$t('customerquality.questionType')">
      <el-select v-model="dataForm.questionType" :placeholder="$t('customerquality.questionType')">
        <el-option v-for="item in questionTypeList" :key="item.value" :label="item.label" :value="item.value">
        </el-option>
      </el-select>
    </el-form-item>
    <el-form-item prop="status" :label="$t('basic.status')">
      <el-select v-model="dataForm.status" :placeholder="$t('basic.status')">
        <el-option v-for="item in options" :key="item.value" :label="item.label" :value="item.value">
        </el-option>
      </el-select>
    </el-form-item>
  </el-form>
</template>

<script>
import debounce from "lodash/debounce";
import basicAdd from "@/mixins/basic-add";
export default {
  mixins: [basicAdd],
  data() {
    return {
      urlOptions: {
        submitURL: "/customerquality/qmsCustomerComplaintManagement/",
        infoURL: "/customerquality/qmsCustomerComplaintManagement//{id}"
        // getTypeListURL: '/basic/qmsProductType/page'
      },
      currentStageList: [
        {
          value: 0,
          label: '接受投诉阶段'
        },
        {
          value: 1,
          label: '解释澄清阶段'
        },
        {
          value: 2,
          label: '提出解决方案阶段'
        },
        {
          value: 3,
          label: '回访阶段'
        }
      ],
      questionTypeList: [
        {
          value: 0,
          label: '产品质量题'
        },
        {
          value: 1,
          label: '售后服务题'
        },
        {
          value: 2,
          label: '物流配送问题'
        },
        {
          value: 3,
          label: '单关问题'
        },
        {
          value: 4,
          label: '4系统故问题'
        }
      ],
      options: [
        {
        value: 0,
        label: '不可用'
      },
      {
        value: 1,
        label: '可用'
        }
      ],
      typeList:[],
      visible: false,
      listQuery: {
        limit: 999,
        page:1
      },
      dataForm: {
        id: "",
        currentStage:null,
        customerName: null,
        description: null,
        questionType: null,
        serialNumber: null,
        status: null,
      },
    };
  },
  computed: {
    dataRule() {
      return {
        code: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        name: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ]
      };
    },
  },
  methods: {
    init(id) {
      this.dataForm.id = id || ""
      // this.dataForm.dictTypeId = dictTypeId || "";
      this.visible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields()
        if (this.dataForm.id) {
          this.getInfo();
        } else {
          // this.getCode()
        }
      });
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/customerquality/qmsCustomerComplaintManagement/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](this.urlOptions.submitURL, this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  console.log(1111);
                  this.visible = false;
                  this.$emit("successSubmit");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
